"use strict";
/* eslint-disable @typescript-eslint/array-type */
/* eslint-disable @typescript-eslint/ban-types */
/* eslint-disable no-restricted-globals */
Object.defineProperty(exports, "__esModule", { value: true });
exports.readonlyWeakMap = exports.readonlyMap = exports.readonlyWeakSet = exports.readonlySet = exports.readonlyNow = exports.validReadonlyDate = exports.readonlyDate = exports.readonlyURL = exports.readonlyURLSearchParams = exports.principledArray = void 0;
/**
 * Copies the provided immutable array and returns the result as a principled array.
 */
const principledArray = (immutableArray) => {
    // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
    return [...immutableArray];
};
exports.principledArray = principledArray;
const readonlyURLSearchParams = (
// eslint-disable-next-line functional/prefer-immutable-types
init) => new URLSearchParams(
// eslint-disable-next-line @typescript-eslint/consistent-type-assertions, functional/prefer-readonly-type
init);
exports.readonlyURLSearchParams = readonlyURLSearchParams;
const readonlyURL = (url, 
// eslint-disable-next-line functional/prefer-immutable-types
base) => {
    // eslint-disable-next-line functional/no-try-statements
    try {
        // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
        return new URL(url, base);
    }
    catch {
        /* returning undefined below results in a better mutation score */
    }
    return undefined;
};
exports.readonlyURL = readonlyURL;
const readonlyDate = (
// eslint-disable-next-line functional/prefer-immutable-types
value
// eslint-disable-next-line @typescript-eslint/consistent-type-assertions
) => new Date(value);
exports.readonlyDate = readonlyDate;
const validReadonlyDate = (
// eslint-disable-next-line functional/prefer-immutable-types
value) => {
    // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
    const d = new Date(value);
    return isNaN(d.getMilliseconds()) ? undefined : d;
};
exports.validReadonlyDate = validReadonlyDate;
// eslint-disable-next-line functional/functional-parameters
const readonlyNow = () => Date.now();
exports.readonlyNow = readonlyNow;
// eslint-disable-next-line functional/prefer-immutable-types
const readonlySet = (values) => new Set(values);
exports.readonlySet = readonlySet;
const readonlyWeakSet = (
// eslint-disable-next-line functional/prefer-immutable-types
values) => new WeakSet(values);
exports.readonlyWeakSet = readonlyWeakSet;
const readonlyMap = (
// eslint-disable-next-line functional/prefer-immutable-types
values) => new Map(values);
exports.readonlyMap = readonlyMap;
const readonlyWeakMap = (
// eslint-disable-next-line functional/prefer-immutable-types
values) => new WeakMap(values);
exports.readonlyWeakMap = readonlyWeakMap;
